#!/usr/bin/perl
use lib '/home/erealms/ethereal/mgmt/perl';

#################################################################################
# Created       : Martin Foster
# Modified      : 26-Mar-2006
#################################################################################
#
# Short - Script desgined to assign a short name to all existing handles for
#         reverse lookups.
# Copyright (C) 2000-2006  Martin Foster
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Author of this script can be contacted at the following:
#       E-Mail  : martin@ethereal-realms.org
#       Address : 29-26503 TWP RD 511
#                 Spruce Grove, Alberta
#                 T7Y 1G4
#
#################################################################################

use Ethereal::Database;						# Database handle


#################################################################################
# Data members                                                                  #
#################################################################################


#################################################################################
# Program Area                                                                  #
#################################################################################


	# Connect with database
	$database = new Ethereal::Database();

	# Connect and fetch
	$database->Connect();

	# Find all system handles
	$database->Pull(\$statement, "SELECT PuppetName
		FROM Puppet
		WHERE PuppetPool='system'");

	# Loop
	while (($puppet) = $statement->fetchrow())
	{
		# Time to determine short name
		$short    =  lc($puppet);
		$short    =~ s/-/_/gs;
		$short    =~ s/\s/_/gs;
		$short    =~ s/\W//gs;

		# Check with the database first
		($verify) = $database->DataGet("SELECT PuppetName FROM Puppet WHERE PuppetShort=?", $short); 


		# Debugging
		print "$puppet - $short -";
		
		# Act accordingly
		if ((defined($verify))
		 && ($verify ne $puppet))
		{
			# Remove handle
			$database->Quick("DELETE FROM Puppet WHERE PuppetName=? AND PuppetPool='system'", $puppet);

			# Debug
			print " DEL\n";
		}

		else
		{
			# Update short
			$database->Quick("UPDATE Puppet SET PuppetShort=? WHERE PuppetName=? AND PuppetPool='system'", $short, $puppet);

			# Debug
			print " MOD\n";
		}

	}

	# Finish off
	$statement->finish();

#################################################################################
# Sub-Routines
#################################################################################
